%This file reproduces Table 11 in the paper.
%
clc;
clear
%
% Import data
%importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/mUSIIP.xls');
%importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/mUSUN.xls');
%importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/lynx.xls');
%importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/ssn_yearly.xls');
%importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/SmoothSSN.xls')
importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/Entry.xls');
%importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/Exit.xls');
%
% Selecting and filtering
%y = 100*(log(mIIP) - lag(log(mIIP),12))/12; y=y(13:end);                  % US IIP in monthly growth rate
%y = 100*(log(mUN) - lag(log(mUN),12))/12; y=y(13:end);                   % US UNEMPLOYEMNT RATE in levels                                                                      
%y = log10(LYNX);                                                         % Canadian Lynx
%y = sqrt(SSN(1:end-3));                                                  % Yearly SSN (use square root transformation)
%y = log(MSmoothSSN(1213:end));                                           % Monthly Smoothed SSN (log tansformation)
y = 100*(log(Entry) - lag(log(Entry),4))/4; y=y(5:end);
%y = 100*(log(Exit) - lag(log(Exit),4))/4; y=y(5:end);
%y = y - lag(y,1) ;  % (eventually in change rate)
%Some general parameters
T = length(y);
c = mean(y);
%
%Estimate AR
%
O = ones(length(y),1);
y_ar=ols(y, [O lag(y,1), lag(y,2) lag(y,3), lag(y,4) lag(y,5), lag(y,6) ]);
yhat_ar = y_ar.yhat;
lambda_ar = y_ar.beta;
[LogLik_ar] = LLF(T,y_ar.sige,y_ar.bstd);
%
%Estimate MR-STAR
%
O = ones(length(y),1);
X = [O, lag(y,1) lag(y,2) lag(y,2) lag(y,3), lag(y,4) lag(y,5), lag(y,6) ]; % AR(6) for IP, AR(4) for UN, AR(5) for YSSN, logSSN, sqrt MSSN, AR(6) for DLMSSN, AR(7) for LYNX
W = [];         % Matrix of exogenous covariates
q = lag(y,1);   % 5 for IP, 2 for UN, 1 for SSN, 4 for LYNX
T = length(y);
nX = size(X,2); % # of covariates
nW = 0;         % # of Exogenous variables
M = [];         % Max # of Regimes (if empty the function compute it automatically)
rob = 1;        % HAC-robust test ?
flag = 1;       % the q is part of the covariates ?
sig = 0.01;      % nominal size (0.01 for IP and UN, 0.5 YSSN, 0.05 for LYNX)
m=1; 
gamma_0=0; gamma1_0=0;gamma2_0=0;  %initial values
%
% Call the function for MR-STAR model
[yhat_mrstar,ehat_mrstar,alpha,beta,lambda,gamma,c_mrstar,se_mrstar,G,sigma_mrstar,fX,pvalue] = mrstar(y,X,W,q,T,nX,nW,M,rob,flag,sig);
[LogLik_mrstar] = LLF(T,sigma_mrstar,ehat_mrstar);
% Call the function for GSTAR model
[alpha_gstar,beta_gstar,lambda_gstar,gamma1,gamma2,c_gstar,fX_gstar,yhat_gstar,ehat_gstar,G_gstar,sigma_gstar,se_gstar]=parestGSTARlm(y,X,W,q,T,nX,nW,m,gamma1_0,gamma2_0,c(1));
[LogLik_gstar] = LLF(T,sigma_gstar,ehat_gstar);
%
%Some change in name of variables
%
F_ar = yhat_ar; F_mrstar = yhat_mrstar; F_gstar = yhat_gstar;
mu_ar = mean(F_ar,1); mu_mrstar = mean(F_mrstar,1); mu_gstar = mean(F_gstar,1);
sigma_ar = var(F_ar); sigma_mrstar = var(F_mrstar); sigma_gstar = var(F_gstar);
T_ar=length(F_ar); T_mrstar=length(F_mrstar); T_gstar=length(F_gstar);
Pdens_ar=zeros(T_ar,1); Pdens_mrstar=zeros(T_mrstar,1); Pdens_gstar=zeros(T_gstar,1);
%
%Parameters for different typws of SR.
%
a=0.1;
aleph=0.5;
k=1;
d=2;
beta=0.3;
thresh = 7.5;
%
% Average the Predictive densities (or Fan Chart upper-lower percentiles);
%
for i=1:T
Pdens_ar(i,:) = (1/size(F_ar,2))*(sum(pdf('norm',F_ar(i,:),mu_ar,sigma_ar),2));
Pdens_mrstar(i,:) = (1/size(F_mrstar,2))*(sum(pdf('norm',F_mrstar(i,:),mu_mrstar,sigma_mrstar),2));
Pdens_gstar(i,:) = (1/size(F_gstar,2))*(sum(pdf('norm',F_gstar(i,:),mu_gstar,sigma_gstar),2));
end
y_ar = Pdens_ar; y_mrstar = Pdens_mrstar;  y_gstar = Pdens_gstar;
%
%   Then, select bandwidth for the Rolling Window
%
alpha = 0.05;                    % 0.01 for IP and UN, 0.05 for others.
H = 12;                          % maximum-step ahead estimation
h = 2;                           % h-step ahead estimation
bw = 50;                        % rolling window
n = T-bw+H-h;                    % Evaluation period

oos_reg0=[]; oos_reg1=[]; oos_reg2=[]; oos_reg3=[]; yoos1=[]; yoos2=[]; yoos3=[]; predreg=[];
% without out of sample
for i=1:T-(bw+n)+1
    [B0 Bint0 R0] = regress(y(i:i+bw-1,:),y_ar(i:i+bw-1,:));
    [B1 Bint1 R1] = regress(y(i:i+bw-1,:),y_mrstar(i:i+bw-1,:));
    [B2 Bint2 R2] = regress(y(i:i+bw-1,:),y_gstar(i:i+bw-1,:));
    %R1= y_ar(i:i+bw-1,:) - y_ar.yhat(i:i+bw-1,:);
    oos_reg0(i,:)=   y_ar(bw+i,:);
    oos_reg1(i,:)=   yhat_ar(bw+i,:);
    oos_reg2(i,:)=   yhat_mrstar(bw+i,:);
    oos_reg3(i,:)=   yhat_gstar(bw+i,:);
    yoos1(i,:) = y_ar(bw+i,:);
    yoos2(i,:) = y_mrstar(bw+i,:);
    yoos3(i,:) = y_gstar(bw+i,:);
    
end
%
%Start with Scoring Rules
%
%Compute the SR for different models estiamted
[logS_ar] = logScore(yoos1, T); [logS_mrstar] = logScore(yoos2, T); [logS_gstar] = logScore(yoos3, T);
[Qsr_ar] = qscore(yoos1,y_ar); [Qsr_mrstar] = qscore(yoos2,y_mrstar); [Qsr_gstar] = qscore(yoos3,y_gstar);
[QuantS_ar] = QuantileS(yoos1, alpha); [QuantS_mrstar] = QuantileS(yoos2, alpha); [QuantS_gstar] = QuantileS(yoos3, alpha);
[CRPS_ar] = CRPS(oos_reg1, c); [CRPS_mrstar] = CRPS(oos_reg2, c); [CRPS_gstar] = CRPS(oos_reg3, c);
%
SR_ar = [Qsr_ar, logS_ar, CRPS_ar, QuantS_ar];
SR_mrstar = [Qsr_mrstar, logS_mrstar, CRPS_mrstar, QuantS_mrstar];
SR_gstar = [Qsr_ar, logS_ar, CRPS_ar, QuantS_ar];
%
%Compute AG test statistic for comparison of AR vs MRSTAR;
%
Delta_1 =  SR_mrstar - SR_ar;
sigma_1 = 1/(T+H-1)*sum(kron(mean(y_ar,2), Delta_1)).^2;
t_val_1 = sqrt(n)*(Delta_1./sigma_1);
CDF_1 = cdf('t', t_val_1, T+H-1);
Pval_1 = 1-CDF_1;
%
%Compute AG test statitic for comparison of MRSTAR vs GSTAR;
%
Delta_2 =  SR_gstar - SR_mrstar;
sigma_2 = 1/(T+H-1)*sum(kron(mean(y_ar,2), Delta_2)).^2;
t_val_2 = sqrt(n)*(Delta_2./sigma_1);
CDF_2 = cdf('t', t_val_2, T+H-1);
Pval_2 = 1-CDF_2;
%
%% RESULTS
disp('------------------------------------------------------------------------------------------------------------------------------------------------------------------')
disp('            SCORING RULES for the ESTIMATED MODELS            ')
disp('------------------------------------------------------------------------------------------------------------------------------------------------------------------')
disp('          MRSTAR        |      AR   |     sigma_n    |      t_n      |      Pval     ')
disp(['QSR: ', num2str(Qsr_mrstar), '     | ', num2str(Qsr_ar) '   | ', num2str(sigma_1(1)), '   |  ', num2str(t_val_1(1)), '   |   ',  num2str(Pval_1(1))])
disp('        ')
disp(['LogS: ', num2str(logS_mrstar),'        | ',num2str(logS_ar) '  |  ', num2str(sigma_1(2)), '  |  ', num2str(t_val_1(2)), '  |   ',  num2str(Pval_1(2))])
disp('        ')
disp(['CRPS: ', num2str(CRPS_mrstar),'     | ',num2str(CRPS_ar) '  |  ', num2str(sigma_1(4)), '  |  ', num2str(t_val_1(3)), '   |  ',  num2str(Pval_1(3))])
disp('        ')
disp(['QuantS: ', num2str(QuantS_mrstar),'     | ',num2str(QuantS_ar) ' | ', num2str(sigma_1(4)),'| ', num2str(t_val_1(4)), ' |  ',  num2str(Pval_1(4))])
disp('------------------------------------------------------------------------------------------------------------------------------------------------------------------')
%% RESULTS
disp('------------------------------------------------------------------------------------------------------------------------------------------------------------------')
disp('------------------------------------------------------------------------------------------------------------------------------------------------------------------')
disp('          GSTAR        |      MRSTAR   |     sigma_n    |      t_n      |      Pval     ')
disp(['QSR: ', num2str(Qsr_gstar), '   | ', num2str(Qsr_mrstar) '   | ', num2str(sigma_2(1)), '   |  ', num2str(t_val_2(1)), '   |   ',  num2str(Pval_2(1))])
disp('        ')
disp(['LogS: ', num2str(logS_gstar),'         | ',num2str(logS_mrstar) '  |  ', num2str(sigma_2(2)), '  |  ', num2str(t_val_2(2)), '  |   ',  num2str(Pval_2(2))])
disp('        ')
disp(['CRPS: ', num2str(CRPS_gstar),'     | ',num2str(CRPS_mrstar) '  |  ', num2str(sigma_2(3)), '  |  ', num2str(t_val_2(3)), '   |  ',  num2str(Pval_2(3))])
disp('        ')
disp(['QuantS: ', num2str(QuantS_gstar),'     | ',num2str(QuantS_mrstar) ' | ', num2str(sigma_2(4)),'| ', num2str(t_val_2(4)), ' |  ',  num2str(Pval_2(4))])
disp('------------------------------------------------------------------------------------------------------------------------------------------------------------------')