%  This file reproduces Figure 2 in EZC              
%
clc
clear
% Deterninistic Sample
eta = -6:.1:6;   

% Declare the Stukel parametrization for function "h(gamma)"
% SYMMETRIC CASE >>> STAR
[GL1, MU1] = h_gamma(eta', 0, 0);
[GL2, MU2] = h_gamma(eta', .25, .25);
[GL3, MU3] = h_gamma(eta', -1, -1);
% ASYMMETRIC CASE >>> GSTAR
[GL4, MU4] = h_gamma(eta', -.25, 1);
[GL5, MU5] = h_gamma(eta', .5, -2);
[GL6, MU6] = h_gamma(eta', -2, 4);
[GL7, MU7] = h_gamma(eta', .25, 1);
[GL8, MU8] = h_gamma(eta', .5, 2);
[GL9, MU9] = h_gamma(eta', 2, 4);

%RESULTS

figure(1)
p = plot(eta, MU1, eta, MU2, eta, MU3, eta, MU4, eta, MU5, eta, MU6,...
    eta, MU7, eta, MU8, eta, MU9);                         
xlabel('\eta_t')  ;
ylabel('G (\gamma1, \gamma2; \eta_t)')  ;                    
title('THE PROPOSED TRANSITION FUNCTION')  ; 
axis tight;
legend('\gamma_1 = 0, \gamma_2 = 0', '\gamma_1 = .25, \gamma_2 = .25',...
    '\gamma_1 = -1, \gamma_2 = -1', '\gamma_1 = -0.25, \gamma_2 = 1',...
    '\gamma_1 = 0.5, \gamma_2 = -2', '\gamma_1 = -2, \gamma_2 = 4',...
    '\gamma_1 = .25, \gamma_2 = 1', '\gamma_1 = 0.5, \gamma_2 = 2',...
    '\gamma_1 = 2, \gamma_2 = 4',2)
set(p(1:3),'LineWidth',2)
set(p(4),'Marker','*')
set(p(5),'Marker','o')
set(p(6),'Marker','sq')
set(p(7),'Marker','x')
set(p(8),'Marker','*')
set(p(9),'LineWidth',2)

save('G_stukel', 'GL1', 'GL2', 'GL3', 'GL4', 'GL5', 'GL6', 'GL7', 'GL8', 'GL9')