function [Gcgamma2] = Gcgamma2(gamma1, gamma2, h, eta, eta_t, s, T)
%This file compute the first derivatives of G on gamma1.



%Define the first DERIVATIVES of Stukel function (formulas 71 and 72 in EZC)
dh11 = zeros(1,T);
dh12 = zeros(1,T);
dh13 = zeros(1,T);

dh21 = (-1/gamma2).*(exp(1 - gamma2.*abs(eta))).*(1/gamma2 + abs(eta)) ; 
dh22 = zeros(1,T);
dh23 = (1/gamma2).*log(gamma2.*abs(eta)-1) + abs(eta)./(gamma2.*abs(eta)-1); 
         
         
if gamma1 > 0
    dh1 = dh11;
elseif gamma1 == 0
    dh1 = dh12;
else dh1 = dh13;
end

if gamma2 > 0
   dh2 = dh21;
elseif gamma2 == 0
    dh2 = dh22 ;
else dh2 = dh23;
end
dh1 = dh1(1,length(eta));
dh2 = dh2(1,length(eta));

%Set the components of eq 70
g = exp(-h.*(eta_t));
f = -((eta_t) <=0).*(dh2') + ((eta_t) >=0).*(dh1');
f_star = -g;
df = (s <=0).*(dh2') + (s >=0).*(dh1');
df_star = f_star.*df ;
ddf = (s <=0).*(dh2') + (s >=0).*(dh1');
D4 = 1 + g.^4 + 4*g.^2 + 2*g.^2 + 4*g + 4*g.^3;
% Compute G_gamma1 (eq. 70)
Gcgamma2 = (df_star.*f + f_star.*ddf)./D4;
end