function [Ggamma1gamma1] = Ggamma1gamma1(gamma1, gamma2, h, eta, eta_t,T)
%This file compute the first derivatives of G on gamma1.


%Define the first DERIVATIVES of Stukel function (formulas 71 and 72 in EZC)
dh11 = (-1/(gamma1^2)).*(exp(abs(eta))- 1).*(abs(eta)-1) ; 
dh12 = zeros(1,T);
dh13 = (-1/(gamma1^2)).*log(1 - gamma1.*abs(eta)) + abs(eta)./(1-gamma1.*abs(eta)) ; 

dh21 = zeros(1,T);
dh22 = zeros(1,T);
dh23 = zeros(1,T); 
         
if gamma1 > 0
    dh1 = dh11;
elseif gamma1 == 0
    dh1 = dh12;
else dh1 = dh13;
end

if gamma2 > 0
   dh2 = dh21;
elseif gamma2 == 0
    dh2 = dh22 ;
else dh2 = dh23;
end
dh1 = dh1(1,length(eta));
dh2 = dh2(1,length(eta));

%Define the SECOND DERIVATIVES of Stukel function (formulas 71 and 72 in EZC)
ddh11 = (exp(abs(eta))- 1).*((1/gamma1).*(1/(gamma1^3) - 2.*(1/gamma1).*abs(eta)+(abs(eta)).^2)) ; 
ddh12 = zeros(1,T);
ddh13 = (1/(gamma1^2)).*(abs(eta)./(1-gamma1.*abs(eta))).*(1/(gamma1^2).*log(1-gamma1*abs(eta))+ (1+abs(eta).*(1+abs(eta).*(1-gamma1))./(1-gamma1.*abs(eta))) ) ; 

ddh21 = zeros(1,T);
ddh22 = zeros(1,T);
ddh23 = zeros(1,T); 
         
if gamma1 > 0
    ddh1 = ddh11;
elseif gamma1 == 0
    ddh1 = ddh12;
else ddh1 = ddh13;
end

if gamma2 > 0
   ddh2 = ddh21;
elseif gamma2 == 0
    ddh2 = ddh22 ;
else ddh2 = ddh23;
end
ddh1 = ddh1(1,length(eta));
ddh2 = ddh2(1,length(eta));


%Set the components of eq 70
g = exp(-h.*(eta_t));
f = -h.*(eta_t);
f_star = -g;
df = ((eta_t) <=0).*(dh2') + ((eta_t) >=0).*(dh1');
df_star = f_star.*df ;
ddf = ((eta_t) <=0).*(ddh2') + ((eta_t) >=0).*(ddh1');
D4 = 1 + g.^4 + 4*g.^2 + 2*g.^2 + 4*g + 4*g.^3;
% Compute G_gamma1 (eq. 70)
Ggamma1gamma1 = (df_star.*f + f_star.*ddf)./D4;
end