function [E,H] = Hessian_aux(z, s, res_1, theta, k, sigma2_aux1)
%This function compute the hessian for the ALL-IN-ONE test of Symmetry.
u1= res_1;
w1=z(:,2); w2= z(:,3); w=[w1;w2];

%Define the elements of the block matrix 
dULLdbeta1dbeta1 = w.^2;
dULLdbeta1dbeta2 = (w.^2).*repmat(s,2,1);
dULLdbeta1dbeta3 = (w.^2).*repmat(s.^2,2,1);
dULLdbeta1dbeta4 = (w.^2).*repmat(s.^3,2,1);
dULLdbeta2dbeta1 = (w.^2).*repmat(s,2,1);
dULLdbeta2dbeta2 = (w.^2).*repmat(s.^2,2,1);
dULLdbeta2dbeta3 = (w.^2).*repmat(s.^3,2,1);
dULLdbeta2dbeta4 = (w.^2).*repmat(s.^4,2,1);
dULLdbeta3dbeta1 = (w.^2).*repmat(s.^2,2,1);
dULLdbeta3dbeta2 = (w.^2).*repmat(s.^3,2,1);
dULLdbeta3dbeta3 = (w.^2).*repmat(s.^4,2,1);
dULLdbeta3dbeta4 = (w.^2).*repmat(s.^5,2,1);
dULLdbeta4dbeta1 = (w.^2).*repmat(s.^3,2,1);
dULLdbeta4dbeta2 = (w.^2).*repmat(s.^4,2,1);
dULLdbeta4dbeta3 = (w.^2).*repmat(s.^5,2,1);
dULLdbeta4dbeta4 = (w.^2).*repmat(s.^6,2,1);

%And the vector of estimated residual to multiply for each block-element
one= ones(length(theta),1);
U = kron(one, u1);

E = [sum(U.*dULLdbeta1dbeta1), sum(U.*dULLdbeta1dbeta2), sum(U.*dULLdbeta1dbeta3), sum(U.*dULLdbeta1dbeta4);
     sum(U.*dULLdbeta2dbeta1), sum(U.*dULLdbeta2dbeta2), sum(U.*dULLdbeta2dbeta3), sum(U.*dULLdbeta2dbeta4);
     sum(U.*dULLdbeta3dbeta1), sum(U.*dULLdbeta3dbeta2), sum(U.*dULLdbeta3dbeta3), sum(U.*dULLdbeta3dbeta4);
     sum(U.*dULLdbeta4dbeta1), sum(U.*dULLdbeta4dbeta2), sum(U.*dULLdbeta4dbeta3), sum(U.*dULLdbeta4dbeta4);
];


% Finally we get the Hessian          
H = -sigma2_aux1^(-1).*(k'*k - E);

end
