clear;
clc;
% Number of time periods
T = 100;
% Random errors
e = randn(T,1);
y = zeros(T,1);
% Y is an AR(1), phi1 = 0.5
y(1) = e(1)*sqrt(1/(1-.5^2));
for t=2:T
y(t)=0.5*y(t-1)+e(t);
end
% 10,000 replications
B = 10000;
% Initial place for mu-star
muStar = zeros(B,1);
%% MOVING BLOCK BOOTSTRAP
% Block size
m = 10;
% Loop over B bootstraps
for b=1:B
% ceil(T/m) Uniform random numbers over 1...T-m+1
u = ceil((T-m+1)*rand(ceil(T/m),1));
u = bsxfun(@plus,u,0:m-1)';
% Transform to col vector, and remove excess
u = u(:); u = u(1:T);
% y-star sample simulation
yStar = y(u);
% Mean of y-star
muStar(b) = mean(yStar);
end

%% STATIONARY BOOTSTRAP
% Average block size
%m = 10;
% Loop over B bootstraps
%yRepl = [y;y];
%u = zeros(T,1);
%for b=1:B
%u(1) = ceil(T*rand);
%    for t=2:T
%        if rand<1/m
%            u(t) = ceil(T*rand);
%        else
%            u(t) = u(t-1) + 1;
%        end
%    end
% y-star sample simulation
%yStar = yRepl(u);
% Mean of y-star
%muStar(b) = mean(yStar);
%end

%% STATIONARY AR BOOTSTRAP
%phi = y(1:T-1)\y(2:T);
%ehat = y(2:T)-phi*y(1:T-1);
%etilde = ehat-mean(ehat);
%yStar = zeros(T,1);
%yRepl = [y;y];
%u = zeros(T,1);
%for i=1:B
% Initialize to one of the original values
%    yStar(1) = y(ceil(T*rand));
% Indices for errors
%    u = ceil((T-1)*rand(T,1));
% Recursion to simulate AR
%    for t=2:T
%        yStar(t) = phi*yStar(t-1) + ehat(u(t));
%    end
    % y-star sample simulation
%    yStar = yRepl(u);
% Mean of y-star
    %muStar(i) = mean(yStar);
%end

%% NONPARAMETRIC BOOTSTRAP FOR REGRESSION
%n = 100; x = randn (n,2) ; e = randn(n,1); y = x*ones(2,1)+e ;
% Bhat
%Bhat = x\y ; ehat = y - x*Bhat ;
%B = 1000;
% Initialize BStar
%BStar = zeros (B,2) ;
% Loop over B bootstraps
%for b =1:B
% Uniform random numbers over 1 . . . n
%    u = ceil(n*rand(n,1)) ;
% x?star sample simulation
%    yStar = y(u) ;
%    xStar = x(u,:);
% Mean of x?star
%    BStar(b,:) = mean(xStar\yStar)' ;
%end
%Berr = bsxfun(@minus,BStar,Bhat') ;
%bootstrapVCV = Berr'*Berr/B
%trueVCV = eye(2)/100
%OLSVCV = (e'*e)/n*(inv(x'*x ))