function [tvh1,tvh2,tvh3,tvG1,tvG2,tvG3,phit_1,phit_2,phit_3,thetat_1,thetat_2,thetat_3]...
    = tv_par(eta,phi0_tilde, phi1_tilde, phi2_tilde, theta0_tilde, theta1_tilde, theta2_tilde, gamma11,gamma21,lambda1,lambda2,T,p)
%This function define the TIME VARYING PARAMETERS

phi = [phi0_tilde, phi1_tilde, phi2_tilde]';
theta = [theta0_tilde, theta1_tilde, theta2_tilde]';

%Define the Stukel function (fromula 2-3)
h111 = (gamma11^(-1))*(exp(gamma11.*abs(eta)) - 1) ; 
h112 = zeros(size(eta)) ;
h113 = (-gamma11^(-1))*log(1 - gamma11.*abs(eta)) ; 

h211 = (-gamma21^(-1))*(exp(gamma21.*abs(eta)) - 1) ;
h212 = zeros(size(eta)) ;
h213 = (gamma21^(-1))*log(1 - gamma21.*abs(eta)) ; 
         
if gamma11 > 0
    h11 = h111;
elseif gamma11 == 0
    h11 = h112;
else h11 = h113;
end

if gamma21 > 0
   h21 = h211;
elseif gamma21 == 0
    h21 = h212 ;
else h21 = h213;
end

%Define the TIME VARYING h_gamma, mu_gamma and G for the tree different
%form of nonlinear time variation
tvh1 = ((eta) <=0).*(h21) + ((eta) >0).*(h11);
tvh2 = (((eta).^2) <=0).*(h21) + (((eta).^2) >0).*(h11);
tvh3 = (eta <=0).*(h21) + (eta >0).*(h11);

tvG1 = (1 + exp(-tvh1)).^(-1) - .5;
tvG2 = (1 + exp(-tvh2)).^2;
tvG3 = (1 + exp(-tvh3)).^(-1) - .5;

%Define the time varying parameter phi(t) and theta(t)
phit_1 = repmat(phi,1,T-p) + lambda1*tvG1;  %GLSTAR1 time variation
phit_2 = repmat(phi,1,T-p) + lambda1*tvG2;  %GLSTAR2 time variation
phit_3 = repmat(phi,1,T-p) + lambda1*tvG3;  %Cubic time variation

thetat_1 = repmat(theta,1,T-p) + lambda2*tvG1; %GLSTAR1 time variation
thetat_2 = repmat(theta,1,T-p) + lambda2*tvG2; %GLSTAR2 time variation
thetat_3 = repmat(theta,1,T-p) + lambda2*tvG3; %Cubic time variation
end